package JSPservletPkg;
import javax.servlet.http.*;
/**
 * PageBox API implementation.
 * <p>Copyright (c) 2000-2001
 * <p>Copyright (c) 2000-2001 Alexis Grandemange</p>
 * <pre>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * </pre>
 * <p>I included a copy of the GNU Lesser General Public License lesser.txt
 * in this directory.</p>
 * <p>alexis.grandemange@pagebox.net</p>
 * @author  Alexis Grandemange
 * @version 1, 0
 */
public class PageBoxAPI {
  /** Relevant JSPloader. */
  JSPloader loader = null;
  /** Path to the current servlet. */
  String pathInfo = null;
  /**
   * Constructor.
   * Uses the class loader to identify the archive and
   * the request to identify the servlet.
   * @param     cl ClassLoader.
   * @param     request HTTP request.
   */
  public PageBoxAPI(ClassLoader cl, HttpServletRequest request) {
    if (cl instanceof JSPloader)
      loader = (JSPloader)cl;
    if (pathInfo == null)
      pathInfo = request.getPathInfo();
  }
  /**
   * Returns the unique identifier of the PageBox.
   */
  public String getID() {
    if (loader != null)
      return loader.handler.ID;
    return null;
  }
  /**
   * Logs a message.
   * @param     msg message to log.
   */
  public void log(String msg) {
    if (loader == null)
      return;
    if (pathInfo != null)
      loader.handler.log.userprint(loader.handler.contextPath + "/" +
        loader.jarName + "/" + pathInfo + ":" + msg);
    else
      loader.handler.log.userprint(loader.handler.contextPath + "/" +
        loader.jarName + ":" + msg);
  }
}
