package JSPservletPkg;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import org.osgi.service.http.*;
import com.sun.jes.service.http.auth.basic.*;
/**
 * Log display servlet.
 * <p>Copyright (c) 2000-2001 Alexis Grandemange</p>
 * <pre>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * </pre>
 * <p>I included a copy of the GNU Lesser General Public License lesser.txt
 * in this directory.</p>
 * <p>alexis.grandemange@pagebox.net</p>
 * @author  Alexis Grandemange
 * @version 1, 0
 */
public class ServletLog extends HttpServlet implements HttpContext {
  /** Invoked by Servlet container. */
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
  /**
   * GET request handling.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    PrintWriter out = new PrintWriter (response.getOutputStream());
    out.println(
      "<html><head><title>log display</title></head><body><h2>log display</h2>");
    if ((handler.log == null) || (handler.logfile == null)) {
      out.println(
        "<p><font color=#DB1260 size=4><i>log not set</i></font></body></html>");
      out.flush();
      return;
    }
    File f = handler.getFile(handler.logfile);
    out.println("<p><font size=3>" + f.getAbsolutePath() + "</font>");
    if ((f == null) || !f.exists()) {
      out.println(
        "<p><font color=#DB1260 size=4><i>log empty</i></font></body></html>");
      out.flush();
      return;
    }
    out.println("<form  action=ServletLog method=\"GET\">");
    out.println(
"<font face=\"Helvetica\"><input type=\"Submit\" value=\"Clear\" name=\"Clear\"></font></form>");
    if (request.getParameter("Clear") != null) {
      handler.log.clear();
      out.println(
        "<p><font color=#DB1260 size=4><i>log cleared</i></font></body></html>");
      out.flush();
      return;
    }
    BufferedReader br = new BufferedReader(new InputStreamReader(
      new FileInputStream(f)));
    String ln = null;
    while ((ln = br.readLine()) != null) {
      if (ln.startsWith("ERROR ") || ln.startsWith("EXCEP "))
        out.println("<font face=\"Helvetica\" color=#DB1260 size=2><b>" + ln +
          "</b></font></br>");
      else
      if (ln.startsWith("USER "))
        out.println("<font face=\"Helvetica\" color=green size=2><b>" + ln +
          "</b></font></br>");
      else
        out.println("<font face=\"Helvetica\" size=2>" + ln + "</font></br>");
    }
    out.println("</body></html>");
    out.flush();
  }
  public String getServletInfo() {
    return "JSPservletPkg.ServletLog Information";
  }
  /**
   * JSPhandler that created ServletLog.
   * It implements also BundleActivator, ServiceListener.
   */
  JSPhandler handler;
  /** Page access security. */
  BasicSchemeHandler basic;
  /**
   * Constructor.
   * @param     jh JSPhandler that created it.
   */
  public ServletLog(JSPhandler jh) {
	  handler = jh;
  }
  /**
   * HttpContext interface getResource.
   * @param     str requested resource.
   */
  public java.net.URL getResource(String str) {
	  return null;
  }
  /**
   * HttpContext interface's getMimeType.
   * @param     str requested resource.
   */
  public String getMimeType(String str) {
	  return null;
  }
  /**
   * HttpContext interface's handleSecurity.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  public boolean handleSecurity(HttpServletRequest req,
    HttpServletResponse res) {
    if (handler.adminUser == null)
      return true;
	  basic = handler.basic;
	  if (basic == null)
      return false;
    BasicSchemeHandler.Response response = basic.getResponse(req);
    if (response == null) {
	    challenge(req, res);
	    return false;
    }
	  String user = response.getName();
	  String password = response.getPassword();
    if ((handler.adminPasswd == null) && handler.adminUser.equals(user))
      return true;
	  if (handler.adminUser.equals(user) && handler.adminPasswd.equals(password))
      return true;
    challenge(req, res);
	  return false;
  }
  /**
   * Invokes BasicSchemeHandler sendChallenge.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  void challenge(HttpServletRequest req, HttpServletResponse res) {
    try {
		  basic.sendChallenge(res, "dummy");
    }
    catch( IOException ioe ) {
		  ioe.printStackTrace();
    }
  }
}
