package JSPservletPkg;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import org.osgi.service.http.*;
import com.sun.jes.service.http.auth.basic.*;
/**
 * Statistics display servlet.
 * <p>Copyright (c) 2000-2001 Alexis Grandemange</p>
 * <pre>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * </pre>
 * <p>I included a copy of the GNU Lesser General Public License lesser.txt
 * in this directory.</p>
 * <p>alexis.grandemange@pagebox.net</p>
 * @author  Alexis Grandemange
 * @version 1, 0
 */
public class ServletStat extends HttpServlet implements HttpContext {
  /** Invoked by Servlet container. */
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
  /**
   * GET request handling.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    PrintWriter out = new PrintWriter (response.getOutputStream());
    out.println(
      "<html><head><title>Statistics</title></head><body><h2>Statistics</h2>");
    Collection classEntries = handler.classEntries.values();
    Properties prop = null;
    String jarName = null;
    if (request.getParameter("statOFF") != null) {
      handler.toStat = false;
      Iterator i = classEntries.iterator();
      while(i.hasNext()) {
        JSPhandler.ClassEntry ce = (JSPhandler.ClassEntry)i.next();
        ce.stat.close();
      }
    } else
    if (request.getParameter("statON") != null) {
      handler.toStat = true;
      Iterator i = classEntries.iterator();
      while(i.hasNext()) {
        JSPhandler.ClassEntry ce = (JSPhandler.ClassEntry)i.next();
        ce.stat.init();
      }
    } else {
      jarName = request.getParameter("jarName");
      if (jarName != null) {
        JSPhandler.ClassEntry ce = (JSPhandler.ClassEntry)
          handler.classEntries.get(jarName);
        prop = ce.stat.prop;
        if (prop != null) {
          String szToClear = (String)request.getParameter("Clear");
          if (szToClear != null)
            prop.clear();
          else {
            Enumeration e = prop.keys();
            out.println("<table border=0 cellspacing=2 cellpadding=2 width=60%>");
            out.println("<tr><td width=20%><font face=\"Helvetica\" size=2>" +
              "<b>Servlet</b></font></td><td width=20%>&nbsp;</td><td width=20%>"
              + "<font face=\"Helvetica\" size=2><b>Invocation number</b></td>" +
              "</font></tr>");
            while(e.hasMoreElements()) {
              String classpath = (String)e.nextElement();
              out.println("<tr><td width=20%><font face=\"Helvetica\" size=2>" +
                classpath + "</font></td><td width=20%>&nbsp;</td><td width=20%>"
                + "<font face=\"Helvetica\" size=2><b>" + prop.get(classpath) +
                "</b></td></font></tr>");
            }
            out.println("</table>");
          }
        }
      }
    }
    out.println("<form  action=ServletStat method=\"GET\">");
    out.println("<table border=0 cellspacing=2 cellpadding=2 width=60%><tr>");
    out.println("<td width=20%><font face=\"Helvetica\"><b>JAR Name :</b>");
    out.println("</td><td width=20%>&nbsp;</td><td width=20%>");
    out.println("<font face=\"Helvetica\"><select name=\"jarName\">");
    Set archs = handler.classEntries.keySet();
    Iterator i = archs.iterator();
    while(i.hasNext()) {
      String option = (String)i.next();
      if ((jarName != null) && option.equals(jarName))
        out.println("<option selected value=\"" + option + "\">" + option);
      else
        out.println("<option value=\"" + option + "\">" + option);
    }
    out.println("</select></font></td></tr><tr>");
    String statsToggle = handler.toStat ? "statOFF" : "statON";
    out.println(
      "<td width=20%><font face=\"Helvetica\"><input type=\"Submit\" value=\"" +
      statsToggle + "\" name=\"" + statsToggle + "\"></td>");
    out.println(
      "<td width=20%><font face=\"Helvetica\"><input type=\"Submit\" value=\"" +
      "Clear\" name=\"Clear\"></td>");
    out.println(
      "<td width=20%><font face=\"Helvetica\"><input type=\"Submit\" value=\"" +
      "List\" name=\"List\"></td></tr><table></form>");
    if (request.getParameter("statOFF") != null)
      out.println("<p><font color=#DB1260 size=4><i>Stats turned OFF</i></font>");
    else
    if (request.getParameter("statON") != null)
      out.println("<p><font color=#DB1260 size=4><i>Stats turned ON</i></font>");
    else
    if (jarName == null)
      out.println(
        "<p><font color=#DB1260 size=4><i>Select the archive name</i></font>");
    else
    if (prop == null)
      out.println(
        "<p><font color=#DB1260 size=4><i>No stats available (" +
        (handler.toStat ? "set" : "not set") + ")</i></font>");
    out.println("</body></html>");
    out.flush();
  }
  public String getServletInfo() {
    return "JSPservletPkg.ServletStat Information";
  }
  /**
   * JSPhandler that created ServletStat.
   * It implements also BundleActivator, ServiceListener.
   */
  JSPhandler handler;
  /** Page access security. */
  BasicSchemeHandler basic;
  /**
   * Constructor.
   * @param     jh JSPhandler that created it.
   */
  public ServletStat(JSPhandler jh) {
	  handler = jh;
  }
  /**
   * HttpContext interface getResource.
   * @param     str requested resource.
   */
  public java.net.URL getResource(String str) {
	  return null;
  }
  /**
   * HttpContext interface's getMimeType.
   * @param     str requested resource.
   */
  public String getMimeType(String str) {
	  return null;
  }
  /**
   * HttpContext interface's handleSecurity.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  public boolean handleSecurity(HttpServletRequest req,
    HttpServletResponse res) {
    if (handler.adminUser == null)
      return true;
	  basic = handler.basic;
	  if (basic == null)
      return false;
    BasicSchemeHandler.Response response = basic.getResponse(req);
    if (response == null) {
	    challenge(req, res);
	    return false;
    }
	  String user = response.getName();
	  String password = response.getPassword();
    if ((handler.adminPasswd == null) && handler.adminUser.equals(user))
      return true;
	  if (handler.adminUser.equals(user) && handler.adminPasswd.equals(password))
      return true;
    challenge(req, res);
	  return false;
  }
  /**
   * Invokes BasicSchemeHandler sendChallenge.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  void challenge(HttpServletRequest req, HttpServletResponse res) {
    try {
		  basic.sendChallenge(res, "dummy");
    }
    catch( IOException ioe ) {
		  ioe.printStackTrace();
    }
  }
}
